Statistics
| Branch: | Tag: | Revision:

root / INSTALL @ 6567f1d9

History | View | Annotate | Download (6.3 kB)

1
Ganeti quick installation guide
2
===============================
3

    
4
Please note that a more detailed installation procedure is described in
5
the :doc:`install`. A glossary of terms can be found in the
6
:doc:`glossary`.
7

    
8

    
9
Software Requirements
10
---------------------
11

    
12
Before installing, please verify that you have the following programs:
13

    
14
- `Xen Hypervisor <http://www.xen.org/>`_, version 3.0 or above, if
15
  running on Xen
16
- `KVM Hypervisor <http://www.linux-kvm.org>`_, version 72 or above, if
17
  running on KVM. In order to use advanced features, such as live
18
  migration, virtio, etc, an even newer version is recommended (qemu-kvm
19
  versions 0.11.X or above have shown good behavior).
20
- `DRBD <http://www.drbd.org/>`_, kernel module and userspace utils,
21
  version 8.0.7 or above
22
- `LVM2 <http://sourceware.org/lvm2/>`_
23
- `OpenSSH <http://www.openssh.com/portable.html>`_
24
- `bridge utilities <http://www.linuxfoundation.org/en/Net:Bridge>`_
25
- `iproute2 <http://www.linuxfoundation.org/en/Net:Iproute2>`_
26
- `arping <http://www.skbuff.net/iputils/>`_ (part of iputils)
27
- `ndisc6 <http://www.remlab.net/ndisc6/>`_ (if using IPv6)
28
- `Python <http://www.python.org/>`_, version 2.4 or above, not 3.0
29
- `Python OpenSSL bindings <http://pyopenssl.sourceforge.net/>`_
30
- `simplejson Python module <http://code.google.com/p/simplejson/>`_
31
- `pyparsing Python module <http://pyparsing.wikispaces.com/>`_, version
32
  1.4.6 or above
33
- `pyinotify Python module <http://trac.dbzteam.org/pyinotify/>`_
34
- `PycURL Python module <http://pycurl.sourceforge.net/>`_
35
- `ctypes Python module
36
  <http://starship.python.net/crew/theller/ctypes/>`_, if running on
37
  python 2.4 (optional, used for node daemon memory locking)
38
- `socat <http://www.dest-unreach.org/socat/>`_, see :ref:`note
39
  <socat-note>` below
40
- `Paramiko <http://www.lag.net/paramiko/>`_, if you want automated SSH
41
  setup; optional otherwise but manual setup of the nodes required
42
- `affinity Python module <http://pypi.python.org/pypi/affinity/0.1.0>`_,
43
  optional python package for supporting CPU pinning under KVM
44
- `ElementTree Python module <http://effbot.org/zone/element-index.htm>`_,
45
  if running python 2.4 (optional, used by ovfconverter tool)
46
- `qemu-img <http://qemu.org/>`_, if you want to use ovfconverter
47

    
48
These programs are supplied as part of most Linux distributions, so
49
usually they can be installed via the standard package manager. Also
50
many of them will already be installed on a standard machine. On
51
Debian/Ubuntu, you can use this command line to install all required
52
packages, except for DRBD and Xen::
53

    
54
  $ apt-get install lvm2 ssh bridge-utils iproute iputils-arping \
55
                    ndisc6 python python-pyopenssl openssl \
56
                    python-pyparsing python-simplejson \
57
                    python-pyinotify python-pycurl socat \
58
                    python-elementtree qemu
59

    
60
If you want to also enable the `htools` components, which is recommended
61
on bigger deployments (they give you automatic instance placement,
62
cluster balancing, etc.), then you need to have a Haskell compiler
63
installed. More specifically:
64

    
65
- `GHC <http://www.haskell.org/ghc/>`_ version 6.10 or higher
66
- or even better, `The Haskell Platform
67
  <http://hackage.haskell.org/platform/>`_ which gives you a simple way
68
  to bootstrap Haskell
69
- `json <http://hackage.haskell.org/package/json>`_, a JSON library
70
- `network <http://hackage.haskell.org/package/network>`_, a basic
71
  network library
72
- `parallel <http://hackage.haskell.org/package/parallel>`_, a parallel
73
  programming library (note: tested with up to version 3.x)
74
- `curl <http://hackage.haskell.org/package/curl>`_, bindings for the
75
  curl library, only needed if you want these tools to connect to remote
76
  clusters (as opposed to the local one)
77

    
78
All of these are also available as package in Debian/Ubuntu::
79

    
80
  $ apt-get install ghc6 libghc6-json-dev libghc6-network-dev \
81
                    libghc6-parallel-dev libghc6-curl-dev
82

    
83
Note that more recent version have switched to GHC 7.x and the packages
84
were renamed::
85

    
86
  $ apt-get install ghc libghc-json-dev libghc-network-dev \
87
                    libghc-parallel-dev libghc-curl-dev
88

    
89
The compilation of the htools components is automatically enabled when
90
the compiler and the requisite libraries are found. You can use the
91
``--enable-htools`` configure flag to force the selection (at which
92
point ``./configure`` will fail if it doesn't find the prerequisites).
93

    
94
If you want to build from source, please see doc/devnotes.rst for more
95
dependencies.
96

    
97
.. _socat-note:
98
.. note::
99
  Ganeti's import/export functionality uses ``socat`` with OpenSSL for
100
  transferring data between nodes. By default, OpenSSL 0.9.8 and above
101
  employ transparent compression of all data using zlib if supported by
102
  both sides of a connection. In cases where a lot of data is
103
  transferred, this can lead to an increased CPU usage. Additionally,
104
  Ganeti already compresses all data using ``gzip`` where it makes sense
105
  (for inter-cluster instance moves).
106

    
107
  To remedey this situation, patches implementing a new ``socat`` option
108
  for disabling OpenSSL compression have been contributed and will
109
  likely be included in the next feature release. Until then, users or
110
  distributions need to apply the patches on their own.
111

    
112
  Ganeti will use the option if it's detected by the ``configure``
113
  script; auto-detection can be disabled by explicitely passing
114
  ``--enable-socat-compress`` (use the option to disable compression) or
115
  ``--disable-socat-compress`` (don't use the option).
116

    
117
  The patches and more information can be found on
118
  http://www.dest-unreach.org/socat/contrib/socat-opensslcompress.html.
119

    
120

    
121
Installation of the software
122
----------------------------
123

    
124
To install, simply run the following command::
125

    
126
  ./configure --localstatedir=/var --sysconfdir=/etc && \
127
  make && \
128
  make install
129

    
130
This will install the software under ``/usr/local``. You then need to
131
copy ``doc/examples/ganeti.initd`` to ``/etc/init.d/ganeti`` and
132
integrate it into your boot sequence (``chkconfig``, ``update-rc.d``,
133
etc.).
134

    
135

    
136
Cluster initialisation
137
----------------------
138

    
139
Before initialising the cluster, on each node you need to create the
140
following directories:
141

    
142
- ``/etc/ganeti``
143
- ``/var/lib/ganeti``
144
- ``/var/log/ganeti``
145
- ``/srv/ganeti``
146
- ``/srv/ganeti/os``
147
- ``/srv/ganeti/export``
148

    
149
After this, use ``gnt-cluster init``.
150

    
151
.. vim: set textwidth=72 syntax=rst :
152
.. Local Variables:
153
.. mode: rst
154
.. fill-column: 72
155
.. End: